﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinExplorerBar;
using System.Runtime.InteropServices;

namespace MDITest
{
    public partial class Form1 : Form
    {
        Form2 secondForm;
        MdiClient mdiClient;
        
        private const int GWL_STYLE = -16;
        private const int GWL_EXSTYLE = -20;

        private const int WS_BORDER = 0x00800000;
        private const int WS_EX_CLIENTEDGE = 0x00000200;

        private const uint SWP_NOSIZE = 0x0001;
        private const uint SWP_NOMOVE = 0x0002;
        private const uint SWP_NOZORDER = 0x0004;
        private const uint SWP_NOREDRAW = 0x0008;
        private const uint SWP_NOACTIVATE = 0x0010;
        private const uint SWP_FRAMECHANGED = 0x0020;
        private const uint SWP_SHOWWINDOW = 0x0040;
        private const uint SWP_HIDEWINDOW = 0x0080;
        private const uint SWP_NOCOPYBITS = 0x0100;
        private const uint SWP_NOOWNERZORDER = 0x0200;
        private const uint SWP_NOSENDCHANGING = 0x0400;

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int SetWindowLong(IntPtr hWnd, int Index, int Value);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int GetWindowLong(IntPtr hWnd, int Index);

        [DllImport("user32.dll", ExactSpelling = true)]
        private static extern int SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);
        
        private BorderStyle nicht = BorderStyle.None;

        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            this.IsMdiContainer = true;
        }

        private void SetMDIBorderStyle(BorderStyle value)
        {
            // Get styles using Win32 calls
            int style = GetWindowLong(mdiClient.Handle, GWL_STYLE);
            int exStyle = GetWindowLong(mdiClient.Handle, GWL_EXSTYLE);

            // Add or remove style flags as necessary.
            switch (value)
            {
                case BorderStyle.Fixed3D:
                    exStyle |= WS_EX_CLIENTEDGE;
                    style &= ~WS_BORDER;
                    break;

                case BorderStyle.FixedSingle:
                    exStyle &= ~WS_EX_CLIENTEDGE;
                    style |= WS_BORDER;
                    break;

                case BorderStyle.None:
                    style &= ~WS_BORDER;
                    exStyle &= ~WS_EX_CLIENTEDGE;
                    break;
            }

            // Set the styles using Win32 calls
            SetWindowLong(mdiClient.Handle, GWL_STYLE, style);
            SetWindowLong(mdiClient.Handle, GWL_EXSTYLE, exStyle);

            // Update the non-client area.
            SetWindowPos(mdiClient.Handle, IntPtr.Zero, 0, 0, 0, 0,
                SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER |
                SWP_NOOWNERZORDER | SWP_FRAMECHANGED);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            mdiClient = null;

            for (int i = 0; i < this.Controls.Count; i++)
            {
                mdiClient = this.Controls[i] as MdiClient;
                if (mdiClient != null)
                {
                    mdiClient.BackColor = Color.Black;
                    SetMDIBorderStyle(nicht);
                }
            }

            ultraDockManager1.SplitterBarWidth = 0;
                       
            //secondForm = new Form2();
            //secondForm.MdiParent = this;
            //secondForm.Show();
            ultraExplorerBar1.Groups.ExpandAll();
        }
    }
}
